/***********************************
* Copyright 1998 by Kevin MacDonald
* kmacdo01@student.vill.edu
***********************************/

/***********************************
* This is the main data structure 
* that has on it the table of info
* and what not
***********************************/

#include "tab.h"
#include "tab.moc"
#include <qpixmap.h>
#include <qfont.h>

Table::Table(QWidget *parent, const char *name, WFlags f)
  	:QWidget(parent, name, f)
{
  setCaption("XWinWeather");

  current = 0;
  tabular = new tabu(this, "main");

  tabular->setMinimumSize(354,100);

  tabular->setDimensions(0, //#of rows
                         6); //#of columns

  
  tabular->section(0)->setText("City");
  tabular->setHeaderFont(QFont("Times", 10));
  tabular->section(1)->setText("Temp");
  tabular->section(2)->setText("Humid.");
  tabular->section(3)->setText("Baro.");

  tabular->section(4)->setText("Wind");
  tabular->section(5)->setText("Weather Conditions");

  connect(tabular,SIGNAL(activated(int)),SLOT(rowActive(int))); 
  connect(tabular, SIGNAL(tableResized()), SLOT(resizeThis()));
  
  tabular->update();

  connect(tabular, SIGNAL(captionChanged(char *, char *)), SLOT(captionChange(char *, char *)));

}

Table::~Table(){}

Table::setCell(int row, int colnum, char *text, int width)
{
  QPixmap base(width,20), cloud;
  QPainter full;
  QdbtTableCell a;
  cloud.load("cloud.xpm");
  full.begin(&base);
  full.setFont(QFont("Times", 12, QFont::Bold));
  full.drawPixmap(0,0, cloud);
  full.drawText(0,15, text);
  full.end();

  a.setPixmap(&base);
  tabular->changeCell(&a,row,colnum);
  
    
}


Table::addRow(char *city, char *temp, char *hum, char *press, char *wind, char *weath)
{

  tabular->insertRow(-1,FALSE);
  int Row = tabular->numRows() - 1;

  setCell(Row,0,city,100);
  setCell(Row,1,temp,40);
  setCell(Row,2,hum,45);
  setCell(Row,3, press,40);
  setCell(Row,4,wind,85);
  setCell(Row,5,weath,100);
  
  tabular->setColumnWidth(0,100);
  tabular->setColumnWidth(1,40);
  tabular->setColumnWidth(2,45);
  tabular->setColumnWidth(3,40);
  tabular->setColumnWidth(4,85);
  tabular->setColumnWidth(5,100);
//  tabular->fitAll();
  int width = 100+30+45+40+85+100;
  setMaximumSize(width+5, (tabular->numRows())*20+30);
  tabular->resize(width+5, (tabular->numRows())*20+30);
  resize(width+5, (tabular->numRows())*30+30);

}

void Table::resizeEvent(QResizeEvent *)
{
 tabular->resize(width(), height());
}

Table::removeRow(int num){
  tabular->removeRow(num);
}

Table::rowActive(int row){
  char city[8];
  ifstream infile(".xweathrc");
  for (int g=0; g<=row;g++)
    infile.getline(city,8);
  infile.close();
  j = new extweath (city);
  j->show();
}

Table::resizeThis(){
  int width = 100+30+45+40+85+100;
  setMaximumSize(width+5, (tabular->numRows())*20+24);
  tabular->resize(width+5, (tabular->numRows())*20+24);
  resize(width+5, (tabular->numRows())*30+30);  
  }  

Table::captionChange(char *city, char *temp){

      QString xwea(city);
      xwea.append(":");
      xwea.append(temp);
      setCaption(xwea);
      }

  

